#ifndef _TIME_H
#define _TIME_H

typedef long int clock_t;
typedef long int time_t;

struct tm
{
    int tm_sec;
    int tm_min;
    int tm_hour;
    int tm_mday;
    int tm_mon;
    int tm_year;
    int tm_wday;
    int tm_yday;
    int tm_isdst;

    long tm_gmtoff;
    const char* tm_zone;
};

#define CLOCKS_PER_SEC 1000

#ifdef __cplusplus
extern "C"
{
#endif

    /* Returns a number representing how much CPU time has been used by this process. Divide this by CLOCKS_PER_SEC to
     * get the value in seconds. */
    clock_t clock(void);

    /* FIXME: For now, is an alias for clock(), but in seconds. */
    time_t time(time_t* tloc);

    struct tm* localtime(const time_t* timep); // Not implemented.
    struct tm* gmtime(const time_t* timep);    // Not implemented.

#ifdef __cplusplus
}
#endif

#endif